/*
 * cavity.c --- cavity flow Ѥϥǡ
 *              ƣΥץ (1995ǯ2) 
 */

#include <math.h>
#include <stdio.h>

#define N  14
#define U  (2*N+1)*(2*N+1)
#define P  (N+1)*(N+1)
#define T  (2*N*N)
#define SIZE (2*U+P)

#define V 1.0
#define nurho 1.0		/*     ͡ߦ     */

void number_u(int k, int z[6])
{
    int r;

    if (k % (2 * N) < N) {
	r = k / N;
	z[0] = 2 * k + r;
	z[1] = z[0] + 2 * (2 * N + 1);
	z[2] = z[0] + 2;
	z[3] = z[0] + 2 * N + 2;
	z[4] = z[0] + 1;
	z[5] = z[0] + 2 * N + 1;
    } else {
	r = k / N - 1;
	z[0] = 2 * k + r + 2 * N + 4;	/* 24 ; */
	z[1] = z[0] - 2 * (2 * N + 1);
	z[2] = z[0] - 2;
	z[3] = z[0] - (2 * N + 2);
	z[4] = z[0] - 1;
	z[5] = z[0] - (2 * N + 1);
    }
}

double cal_x(int k)
{
    int r;
    double x;

    r = k / (2 * N + 1);
    x = 1.0 / (2 * N) * r;

    return x;
/*
  if(x>0) return x*x ;
  else return -x*x ;
*/
}

double cal_y(int k)
{
    int r;
    double y;

    r = k % (2 * N + 1);
    y = 1.0 / (2 * N) * r;

    return y;
/*
  return 0.5*y*y ; 
*/
}

int main(int argc, char **argv)		/*L.538 */
{
    FILE *f;
    int i, j, k, zu[6];

    if (argc != 2) {
	fprintf(stderr, "usage: %s <output file name>\n", argv[0]);
	exit(0);
    }
    if ((f = fopen(argv[1], "w")) == NULL) {
	fprintf(stderr, "can't open %s \n", argv[1]);
	exit(1);
    }

    fprintf(f, "%d %d", T, U);
    fprintf(f, "\n");

    for (i = 0; i < U; i++)
	fprintf(f, "%20.15f  %20.15f \n", cal_x(i), cal_y(i));
    fprintf(f, "\n");

    for (i = 0; i < T; i++) {
	number_u(i, zu);
	for (j = 0; j < 6; j++)
	    fprintf(f, " %4d ", zu[j]);
	fprintf(f, "\n");
    }
    fprintf(f, "\n");

    k = 0;
    for (i = 0; i < U; i++) {
	fprintf(f, "%4d \n", k);
	if (i % (2 * (2 * N + 1)) < (2 * N + 1) && (i % 2) == 0)
	    j = 3;
	else
	    j = 2;
	k += j;
    }
    fprintf(f, "\n");

    fprintf(f, "%4d \n", k);
    fprintf(f, "\n");

    fprintf(f, "0.005 1.0 \n");
    fprintf(f, "\n");

    fprintf(f, "%d 0\n", 8 * N);
    fprintf(f, "\n");

    for (k = 1; k < 2 * N; k++)
	fprintf(f, "%4d %23.20f %23.20f \n", k, 0.0, 0.0);

    for (k = 0; k <= (2 * N + 1) * 2 * N; k += (2 * N + 1))
	fprintf(f, "%4d 0.0 0.0 \n", k);

    for (k = (2 * N); k < (2 * N + 1) * (2 * N + 1); k += (2 * N + 1))
	fprintf(f, "%4d %23.20f %23.20f \n", k, 1.0, 0.0);

    for (k = (2 * N + 1) * 2 * N + 1; k < (2 * N + 1) * (2 * N + 1) - 1; k++)
	fprintf(f, "%4d %23.20f %23.20f \n", k, 0.0, 0.0);

    fprintf(f, "\n");

    for (i = 0; i < U; i++)
	fprintf(f, "0.0 0.0\n");

    return 0;
}
