/*
 * navier.c
 *   ƣ  (ɤ Ȥ椭) Υץ (1995ǯ2) 㴳
 *     0. ANSI C ΥץȥĤ
 *     1. ä
 */

#include <math.h>
#include <stdio.h>
#include "matutil.h"

#define  L  50000
#define L2 500000

double menseki(double x0, double x1, double x2,
               double y0, double y1, double y2);
void matprod1(matrix a, matrix b, int l, int m, int n, matrix c);
void matprod2(matrix a, matrix b, matrix c,
              int k, int l, int m, int n, matrix d);
void matprod3(matrix a, matrix b, matrix c, matrix d);
void make(int T, matrix o, vector u, vector v, double nu, double rho,
          vector x, vector y, int **num, int *cum,
          vector fx, vector fy, vector sx, vector sy);
void change(matrix o, int k, int SIZE);
void bound(matrix o, vector u, int *b, int N, int D, int *cum, int SIZE);
void etalu(matrix o, vector u, int SIZE);
void updtel(vector e, int *ie, int *ne, vector we, int *ip, int K);
void updteu(vector e, int *ie, int *ne, vector we, int SIZE);
void newton(int T, matrix o, vector u, vector v, double nu, double rho,
            vector x, vector y, int **num, int *cum,
            vector fx, vector fy, int *b, int N, int D, int SIZE,
            vector sx, vector sy);


int main(int argc, char **argv)
{
    FILE *f1, *f2, *f3;
    int i, j, U, T, SIZE, N, D, ND;
    int *cum, **num, *b;
    double nu, rho;
    vector x, y, u, v, bx, by, fx, fy, sx, sy;
    matrix o;

    if (argc != 4) {
        fprintf(stderr, "usage: %s <input file0> <input file1> <output file>",
                argv[0]);
        exit(1);
    }
    if ((f1 = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't open %s", argv[1]);
        exit(1);
    }
    if ((f2 = fopen(argv[2], "r")) == NULL) {
        fprintf(stderr, "Can't open %s", argv[2]);
        exit(2);
    }

    fscanf(f1, "%d %d", &T, &U);

    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++) {
        fscanf(f1, "%lf %lf", &x[i], &y[i]);
    }

    num = (int **) malloc(T * sizeof(void *));
    if (num == NULL) {
        fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
	exit(1);
    }
    for (i = 0; i < T; i++) {
        num[i] = (int *) malloc(sizeof(int) * 6);
        if (num[i] == NULL) {
            fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
	    exit(1);
        }
    }
    for (i = 0; i < T; i++)
        for (j = 0; j < 6; j++)
            fscanf(f1, "%d", &num[i][j]);

    if ((cum = (int *) malloc(sizeof(int) * U)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ \n");
	exit(1);
    }
    for (i = 0; i < U; i++)
        fscanf(f1, "%d", &cum[i]);

    fscanf(f1, "%d", &SIZE);

    u = new_vector(SIZE);
    v = new_vector(SIZE);
    o = new_matrix(SIZE, SIZE);
    for (i = 0; i < SIZE; i++)
        fscanf(f2, "%lf", &u[i]);
    fclose(f2);

    fscanf(f1, "%lf %lf", &nu, &rho);
    fscanf(f1, "%d %d", &D, &N);

    ND = N + D;

    if ((b = (int *) malloc(sizeof(int) * ND)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ\n");
	exit(1);
    }
    bx = new_vector(ND);
    by = new_vector(ND);
    for (i = 0; i < ND; i++)
        fscanf(f1, "%d %lf %lf", &b[i], &bx[i], &by[i]);

    sx = new_vector(U);
    sy = new_vector(U);
    for (i = 0; i < U; i++)
        sx[i] = sy[i] = 0.0;
    if (N != 0) {
        for (i = D; i < ND; i++) {
            sx[b[i]] = bx[i];
            sy[b[i]] = by[i];
        }
    }

    fx = new_vector(U);
    fy = new_vector(U);
    for (i = 0; i < U; i++)
        fscanf(f1, "%lf %lf", &fx[i], &fy[i]);
    fclose(f1);

    newton(T, o, u, v, nu, rho, x, y, num, cum, fx, fy, b, N, D, SIZE, sx,
           sy);

    free(num);
    free_vector(x);
    free_vector(y);
    free_vector(fx);
    free_vector(fy);

    free(b);
    free(cum);
    free_vector(bx);
    free_vector(by);
    free_vector(sx);
    free_vector(sy);

    if ((f3 = fopen(argv[3], "w")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[3]);
        exit(3);
    }
    for (i = 0; i < SIZE; i++)
        fprintf(f3, "%f \n", u[i]);
    fclose(f3);

    return 0;
}

double menseki(double x0, double x1, double x2,
               double y0, double y1, double y2)
{
    double s;
    s = 0.5 * ((x1 - x0) * (y2 - y0) - (y1 - y0) * (x2 - x0));
    return s;
}

void matprod1(matrix a, matrix b, int l, int m, int n, matrix c)
{
    double s;
    int i, j, k;

    for (i = 0; i < l; i++)
        for (j = 0; j < n; j++) {
            s = 0.0;
            for (k = 0; k < m; k++)
                s += a[i][k] * b[k][j];
            c[i][j] = s;
        }
}

void matprod2(matrix a, matrix b, matrix c,
	      int k, int l, int m, int n, matrix d)
{
    matrix p = new_matrix(k, m);

    matprod1(a, b, k, l, m, p);
    matprod1(p, c, k, m, n, d);

    free_matrix(p);
}

void matprod3(matrix a, matrix b, matrix c, matrix d)
{
    int i, j;
    matrix p = new_matrix(6, 6);
    matrix q = new_matrix(6, 6);

    for (i = 0; i < 6; i++)
        for (j = 0; j < 6; j++)
            q[i][j] = a[j][i];

    matprod2(a, b, c, 6, 6, 3, 6, p);
    matprod1(p, q, 6, 6, 6, d);

    free_matrix(p);
    free_matrix(q);
}

void make(int T, matrix o, vector u, vector v, double nu, double rho,
          vector x, vector y, int **num, int *cum,
          vector fx, vector fy, vector sx, vector sy)
{
    int i, j, k, l;
    double b1, b2, b3, c1, c2, c3, l1, l2, l3, s, t, nurho;
    matrix a, ta, b, c, d, g, hx, hy, mxx, mxy, myx, myy, r;
    matrix kappa[6], kx[6], ky[6];

    a = new_matrix(6, 6);
    ta = new_matrix(6, 6);
    b = new_matrix(6, 6);
    c = new_matrix(6, 6);
    d = new_matrix(6, 1);
    g = new_matrix(3, 3);
    hx = new_matrix(6, 3);
    hy = new_matrix(6, 3);
    mxx = new_matrix(6, 6);
    mxy = new_matrix(6, 6);
    myx = new_matrix(6, 6);
    myy = new_matrix(6, 6);
    r = new_matrix(6, 1);

    for (i = 0; i < 6; i++) {
        kappa[i] = new_matrix(6, 3);
        kx[i] = new_matrix(6, 6);
        ky[i] = new_matrix(6, 6);
    }
    nurho = nu * rho;

    a[0][0] = 1.0;
    a[0][4] = -1.0;
    a[0][5] = -1.0;
    a[1][1] = 1.0;
    a[1][3] = -1.0;
    a[1][5] = -1.0;
    a[2][2] = 1.0;
    a[2][3] = -1.0;
    a[2][4] = -1.0;
    a[3][3] = 4.0;
    a[4][4] = 4.0;
    a[5][5] = 4.0;

    ta[0][0] = 1.0;
    ta[1][1] = 1.0;
    ta[2][2] = 1.0;
    ta[3][1] = -1.0;
    ta[3][2] = -1.0;
    ta[3][3] = 4.0;
    ta[4][0] = -1.0;
    ta[4][2] = -1.0;
    ta[4][4] = 4.0;
    ta[5][0] = -1.0;
    ta[5][1] = -1.0;
    ta[5][5] = 4.0;

    for (l = 0; l < T; l++) {
        s = menseki(x[num[l][0]], x[num[l][1]], x[num[l][2]],
                    y[num[l][0]], y[num[l][1]], y[num[l][2]]);
        if (s < 0.0) {
            printf(" %d ǤѤˤʤäƤޤ\n", l);
            exit(0);
        }
        t = 0.5 / s;

        b1 = t * (y[num[l][1]] - y[num[l][2]]);
        b2 = t * (y[num[l][2]] - y[num[l][0]]);
        b3 = t * (y[num[l][0]] - y[num[l][1]]);

        c1 = t * (x[num[l][2]] - x[num[l][1]]);
        c2 = t * (x[num[l][0]] - x[num[l][2]]);
        c3 = t * (x[num[l][1]] - x[num[l][0]]);

        l1 =
            hypot(x[num[l][2]] - x[num[l][1]],
                  y[num[l][1]] - y[num[l][2]]);
        l2 =
            hypot(x[num[l][2]] - x[num[l][0]],
                  y[num[l][0]] - y[num[l][2]]);
        l3 =
            hypot(x[num[l][0]] - x[num[l][1]],
                  y[num[l][1]] - y[num[l][0]]);

        b[0][0] = 2 * b1;
        b[0][4] = b3;
        b[0][5] = b2;
        b[1][1] = 2 * b2;
        b[1][3] = b3;
        b[1][5] = b1;
        b[2][2] = 2 * b3;
        b[2][3] = b2;
        b[2][4] = b1;
        b[3][1] = b3;
        b[3][2] = b2;
        b[4][0] = b3;
        b[4][2] = b1;
        b[5][0] = b2;
        b[5][1] = b1;

        c[0][0] = 2 * c1;
        c[0][4] = c3;
        c[0][5] = c2;
        c[1][1] = 2 * c2;
        c[1][3] = c3;
        c[1][5] = c1;
        c[2][2] = 2 * c3;
        c[2][3] = c2;
        c[2][4] = c1;
        c[3][1] = c3;
        c[3][2] = c2;
        c[4][0] = c3;
        c[4][2] = c1;
        c[5][0] = c2;
        c[5][1] = c1;

        for (i = 0; i < 3; i++)
            for (j = 0; j < 3; j++)
                if (i != j)
                    g[i][j] = s / 12;
                else
                    g[i][j] = s / 6;

        for (i = 0; i < 3; i++) {
            d[i][0] = s / 6;
            d[i + 3][0] = s / 12;
        }
        t = rho * s / 1260;
        kappa[0][0][0] = 36.0 * t;
        kappa[0][0][1] = 3.0 * t;
        kappa[0][0][2] = 3.0 * t;
        kappa[0][1][0] = -2.0 * t;
        kappa[0][1][1] = -9.0 * t;
        kappa[0][1][2] = -3.0 * t;
        kappa[0][2][0] = -2.0 * t;
        kappa[0][2][1] = -3.0 * t;
        kappa[0][2][2] = -9.0 * t;
        kappa[0][3][0] = -1.0 * t;
        kappa[0][3][1] = -3.0 * t;
        kappa[0][3][2] = -3.0 * t;
        kappa[0][4][0] = 3.0 * t;
        kappa[0][4][1] = -1.0 * t;
        kappa[0][4][2] = -2.0 * t;
        kappa[0][5][0] = 3.0 * t;
        kappa[0][5][1] = -2.0 * t;
        kappa[0][5][2] = -1.0 * t;

        kappa[1][0][0] = -9.0 * t;
        kappa[1][0][1] = -2.0 * t;
        kappa[1][0][2] = -3.0 * t;
        kappa[1][1][0] = 3.0 * t;
        kappa[1][1][1] = 36.0 * t;
        kappa[1][1][2] = 3.0 * t;
        kappa[1][2][0] = -3.0 * t;
        kappa[1][2][1] = -2.0 * t;
        kappa[1][2][2] = -9.0 * t;
        kappa[1][3][0] = -1.0 * t;
        kappa[1][3][1] = 3.0 * t;
        kappa[1][3][2] = -2.0 * t;
        kappa[1][4][0] = -3.0 * t;
        kappa[1][4][1] = -1.0 * t;
        kappa[1][4][2] = -3.0 * t;
        kappa[1][5][0] = -2.0 * t;
        kappa[1][5][1] = 3.0 * t;
        kappa[1][5][2] = -1.0 * t;

        kappa[2][0][0] = -9.0 * t;
        kappa[2][0][1] = -3.0 * t;
        kappa[2][0][2] = -2.0 * t;
        kappa[2][1][0] = -3.0 * t;
        kappa[2][1][1] = -9.0 * t;
        kappa[2][1][2] = -2.0 * t;
        kappa[2][2][0] = 3.0 * t;
        kappa[2][2][1] = 3.0 * t;
        kappa[2][2][2] = 36.0 * t;
        kappa[2][3][0] = -1.0 * t;
        kappa[2][3][1] = -2.0 * t;
        kappa[2][3][2] = 3.0 * t;
        kappa[2][4][0] = -2.0 * t;
        kappa[2][4][1] = -1.0 * t;
        kappa[2][4][2] = 3.0 * t;
        kappa[2][5][0] = -3.0 * t;
        kappa[2][5][1] = -3.0 * t;
        kappa[2][5][2] = -1.0 * t;

        t = rho * s / 315;
        kappa[3][0][0] = 3.0 * t;
        kappa[3][0][1] = 2.0 * t;
        kappa[3][0][2] = 2.0 * t;
        kappa[3][1][0] = 3.0 * t;
        kappa[3][1][1] = 12.0 * t;
        kappa[3][1][2] = 6.0 * t;
        kappa[3][2][0] = 3.0 * t;
        kappa[3][2][1] = 6.0 * t;
        kappa[3][2][2] = 12.0 * t;
        kappa[3][3][0] = 2.0 * t;
        kappa[3][3][1] = 6.0 * t;
        kappa[3][3][2] = 6.0 * t;
        kappa[3][4][0] = 2.0 * t;
        kappa[3][4][1] = 2.0 * t;
        kappa[3][4][2] = 3.0 * t;
        kappa[3][5][0] = 2.0 * t;
        kappa[3][5][1] = 3.0 * t;
        kappa[3][5][2] = 2.0 * t;

        kappa[4][0][0] = 12.0 * t;
        kappa[4][0][1] = 3.0 * t;
        kappa[4][0][2] = 6.0 * t;
        kappa[4][1][0] = 2.0 * t;
        kappa[4][1][1] = 3.0 * t;
        kappa[4][1][2] = 2.0 * t;
        kappa[4][2][0] = 6.0 * t;
        kappa[4][2][1] = 3.0 * t;
        kappa[4][2][2] = 12.0 * t;
        kappa[4][3][0] = 2.0 * t;
        kappa[4][3][1] = 2.0 * t;
        kappa[4][3][2] = 3.0 * t;
        kappa[4][4][0] = 6.0 * t;
        kappa[4][4][1] = 2.0 * t;
        kappa[4][4][2] = 6.0 * t;
        kappa[4][5][0] = 3.0 * t;
        kappa[4][5][1] = 2.0 * t;
        kappa[4][5][2] = 2.0 * t;

        kappa[5][0][0] = 12.0 * t;
        kappa[5][0][1] = 6.0 * t;
        kappa[5][0][2] = 3.0 * t;
        kappa[5][1][0] = 6.0 * t;
        kappa[5][1][1] = 12.0 * t;
        kappa[5][1][2] = 3.0 * t;
        kappa[5][2][0] = 2.0 * t;
        kappa[5][2][1] = 2.0 * t;
        kappa[5][2][2] = 3.0 * t;
        kappa[5][3][0] = 2.0 * t;
        kappa[5][3][1] = 3.0 * t;
        kappa[5][3][2] = 2.0 * t;
        kappa[5][4][0] = 3.0 * t;
        kappa[5][4][1] = 2.0 * t;
        kappa[5][4][2] = 2.0 * t;
        kappa[5][5][0] = 6.0 * t;
        kappa[5][5][1] = 6.0 * t;
        kappa[5][5][2] = 2.0 * t;

        matprod1(a, d, 6, 6, 1, r);

        d[0][0] = (l2 + l3) / 3;
        d[1][0] = (l3 + l1) / 3;
        d[2][0] = (l1 + l2) / 3;
        d[3][0] = l1 / 6;
        d[4][0] = l2 / 6;
        d[5][0] = l3 / 6;
        matprod1(a, d, 6, 6, 1, d);

        matprod2(a, b, g, 6, 6, 3, 3, hx);
        matprod2(a, c, g, 6, 6, 3, 3, hy);

        for (i = 0; i < 6; i++) {
            matprod3(a, kappa[i], b, kx[i]);
            matprod3(a, kappa[i], c, ky[i]);
        }

        matprod2(hx, b, ta, 6, 3, 6, 6, mxx);
        matprod2(hy, b, ta, 6, 3, 6, 6, mxy);
        matprod2(hx, c, ta, 6, 3, 6, 6, myx);
        matprod2(hy, c, ta, 6, 3, 6, 6, myy);

        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                o[cum[num[l][i]]][cum[num[l][j]]] +=
                    nurho * (2.0 * mxx[i][j] + myy[i][j]);
                o[cum[num[l][i]]][cum[num[l][j]] + 1] += nurho * mxy[i][j];
                o[cum[num[l][i]] + 1][cum[num[l][j]]] += nurho * myx[i][j];
                o[cum[num[l][i]] + 1][cum[num[l][j]] + 1] +=
                    nurho * (mxx[i][j]
                             + 2.0 * myy[i][j]);
            }
            for (j = 0; j < 3; j++) {
                o[cum[num[l][i]]][cum[num[l][j]] + 2] -= hx[i][j];
                o[cum[num[l][j]] + 2][cum[num[l][i]]] =
                    -o[cum[num[l][i]]][cum[num[l][j]] + 2];
                o[cum[num[l][i]] + 1][cum[num[l][j]] + 2] -= hy[i][j];
                o[cum[num[l][j]] + 2][cum[num[l][i]] + 1] =
                    -o[cum[num[l][i]] + 1][cum[num[l][j]] + 2];
            }
        }
        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                for (k = 0; k < 6; k++) {
                    o[cum[num[l][i]]][cum[num[l][j]]] +=
                        (kx[i][j][k] + kx[i][k][j])
                        * u[cum[num[l][k]]] +
                        ky[i][k][j] * u[cum[num[l][k]] + 1];
                    o[cum[num[l][i]]][cum[num[l][j]] + 1] += ky[i][j][k]
                        * u[cum[num[l][k]]];
                    o[cum[num[l][i]] + 1][cum[num[l][j]]] += kx[i][j][k]
                        * u[cum[num[l][k]] + 1];
                    o[cum[num[l][i]] + 1][cum[num[l][j]] + 1] +=
                        (ky[i][j][k] + ky[i][k][j])
                        * u[cum[num[l][k]] + 1] +
                        kx[i][k][j] * u[cum[num[l][k]]];
                }
            }
        }
        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                for (k = 0; k < 6; k++) {
                    v[cum[num[l][i]]] += (kx[i][j][k] * u[cum[num[l][j]]]
                                          +
                                          ky[i][j][k] * u[cum[num[l][j]] +
                                                          1]) *
                        u[cum[num[l][k]]];
                    v[cum[num[l][i]] + 1] +=
                        (kx[i][j][k] * u[cum[num[l][j]]] +
                         ky[i][j][k] * u[cum[num[l][j]] +
                                         1]) * u[cum[num[l][k]] + 1];
                }
            }
        }
        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                v[cum[num[l][i]]] += nurho * ((2 * mxx[i][j] + myy[i][j])
                                              * u[cum[num[l][j]]] +
                                              mxy[i][j] *
                                              u[cum[num[l][j]] + 1]);
                v[cum[num[l][i]] + 1] +=
                    nurho * ((mxx[i][j] + 2 * myy[i][j]) *
                             u[cum[num[l][j]] + 1] +
                             myx[i][j] * u[cum[num[l][j]]]);
            }
        }
        for (i = 0; i < 6; i++) {
            for (j = 0; j < 3; j++) {
                v[cum[num[l][i]]] -= hx[i][j] * u[cum[num[l][j]] + 2];
                v[cum[num[l][i]] + 1] -= hy[i][j] * u[cum[num[l][j]] + 2];
            }
            v[cum[num[l][i]]] -=
                rho * r[i][0] * fx[num[l][i]] - d[i][0] * sx[num[l][i]];
            v[cum[num[l][i]] + 1] -=
                rho * r[i][0] * fy[num[l][i]] - d[i][0] * sy[num[l][i]];
        }
        for (i = 0; i < 3; i++)
            for (j = 0; j < 6; j++)
                v[cum[num[l][i]] + 2] += hx[j][i] * u[cum[num[l][j]]]
                    + hy[j][i] * u[cum[num[l][j]] + 1];
    }
    free_matrix(a);
    free_matrix(ta);
    free_matrix(b);
    free_matrix(c);
    free_matrix(d);
    free_matrix(r);
    free_matrix(g);
    free_matrix(hx);
    free_matrix(hy);
    free_matrix(mxx);
    free_matrix(mxy);
    free_matrix(myx);
    free_matrix(myy);
    for (i = 0; i < 6; i++) {
        free_matrix(kappa[i]);
        free_matrix(kx[i]);
        free_matrix(ky[i]);
    }
}

void change(matrix o, int k, int SIZE)
{
    int i;

    for (i = 0; i < SIZE; i++)
        o[k][i] = 0.0;
    o[k][k] = 1.0;
}

void bound(matrix o, vector u, int *b, int N, int D, int *cum, int SIZE)
{
    int i, j;
    for (i = 0; i < D; i++) {
        j = cum[b[i]];
        change(o, j, SIZE);
        change(o, j + 1, SIZE);
        u[j] = 0.0;
        u[j + 1] = 0.0;
    }
    if (N == 0) {
        change(o, 2, SIZE);
        u[2] = 0.0;
    }
}

void etalu(matrix o, vector u, int SIZE)
{
    int i, j, k, jk, irow;
    int *ia, *ie, *nwk, num, *ne, *ip, is, ier;
    double val, work, piv, eps = 1.0e-14;
    double *a, *e;
    vector x, we, b;

    if ((nwk = (int *) malloc(sizeof(int) * (SIZE + 1))) == NULL) {
        printf("etalu:nwkѤΥ꡼­ޤ\n");
    }
    if ((ne = (int *) malloc(sizeof(int) * (2 * (SIZE + 1)))) == NULL) {
        printf("etalu:neѤΥ꡼­ޤ\n");
    }
    if ((ip = (int *) malloc(sizeof(int) * (SIZE + 1))) == NULL) {
        printf("etalu:ipѤΥ꡼­ޤ\n");
    }
    if ((ia = (int *) malloc(sizeof(int) * L)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ ia ѤΥ꡼­ޤ\n");
    }
    if ((ie = (int *) malloc(sizeof(int) * L2)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ ie ѤΥ꡼­ޤ\n");
    }
    if ((a = (double *) malloc(sizeof(double) * L)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ a ѤΥ꡼­ޤ\n");
    }
    if ((e = (double *) malloc(sizeof(double) * L2)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ e ѤΥ꡼­ޤ\n");
    }
    x = new_vector(SIZE + 1);
    we = new_vector(SIZE + 1);
    b = new_vector(SIZE + 1);

    k = 1;
    nwk[0] = 0;
    for (i = 0; i < SIZE; i++) {
        for (j = 0; j < SIZE; j++) {
            if (o[j][i] != 0.0) {
                a[k] = o[j][i];
                ia[k] = j + 1;
                k++;
            }
        }
        nwk[i + 1] = k - 1;
    }

    for (i = 0; i < SIZE; i++)
        b[i + 1] = u[i];

    if (L <= SIZE) {
        printf("INVALID ARGUMENT. %d %d \n", L, SIZE);
        ier = 2;
        return;
    }

    ier = is = ne[0] = ne[1] = num = 0;

    for (i = 1; i <= SIZE; i++)
        ip[i] = 0;
    for (k = 1; k <= SIZE; k++) {
        for (i = 1; i <= SIZE; i++)
            we[i] = 0.0;
        for (i = nwk[k - 1] + 1; i <= nwk[k]; i++)
            we[ia[i]] = a[i];
        if (k != 1) {
            jk = k - 1;
            updtel(e, ie, ne, we, ip, jk);
	    /* COMPUTATION OF ETA */
        }
	/* SELECTION OF PIVOT */
        irow = 0;
        val = 0.0;
        for (i = k; i <= SIZE; i++) {
            work = fabs(we[i]);
            if (work > val) {
                val = work;
                irow = i;
            }
        }
        if (val <= eps) {
            printf("STOP WITH ZERO PIVOT %d \n", k);
            ier = 1;
            return;
        }
        ip[k] = irow;
        if (irow != k) {
            work = we[k];
            we[k] = we[irow];
            we[irow] = work;
        }
	/* WRITE(*,*) (WE[i],I=1,M) */
	/* GENERATION OF ETA */
        piv = - 1.0 / we[k];
        we[k] = - 1.0;
        for (i = k; i <= SIZE; i++) {
            we[i] *= piv;
            if (fabs(we[i]) >= eps) {
                num++;
                e[num] = we[i];
                ie[num] = i;
            }
        }
        ne[2 * k] = num;
        if (k == 1) {
            ne[3] = ne[2];
        }
	else {
            for (i = 1; i < k; i++) {
                if (fabs(we[i]) >= eps) {
                    num++;
                    e[num] = - we[i];
                    ie[num] = i;
                }
            }
            ne[2 * k + 1] = num;
        }
    }
    /* COMPUTION OF X */
    for (k = 1; k <= SIZE; k++)
        x[k] = b[k];
    updtel(e, ie, ne, x, ip, SIZE);
    updteu(e, ie, ne, x, SIZE);

    for (k = 0; k < SIZE; k++)
        u[k] = x[k + 1];

    free(ia);
    free(ie);
    free(nwk);
    free(ne);
    free(ip);
    free(a);
    free(e);
    free_vector(x);
    free_vector(we);
    free_vector(b);
}

void updtel(vector e, int *ie, int *ne, vector we, int *ip, int K)
{
    int i, j, irow;
    double work;

    for (j = 1; j <= K; j++) {
        irow = ip[j];
        if (irow != j) {
            work = we[j];
            we[j] = we[irow];
            we[irow] = work;
        }
        work = we[j];
        we[j] = 0.0;
        for (i = ne[2 * j - 1] + 1; i <= ne[2 * j]; i++)
            we[ie[i]] += e[i] * work;
    }
}

void updteu(double *e, int *ie, int *ne, double *we, int SIZE)
{
    int i, j;
    double work;

    for (j = SIZE; j >= 2; j--) {
        if (ne[2 * j] != ne[2 * j + 1]) {
            work = we[j];
            for (i = ne[2 * j] + 1; i <= ne[2 * j + 1]; i++) {
                we[ie[i]] += e[i] * work;
            }
        }
    }
}

void newton(int T, matrix o, vector u, vector v, double nu, double rho,
            vector x, vector y, int **num, int *cum,
            vector fx, vector fy, int *b, int N, int D, int SIZE,
            vector sx, vector sy)
{
    int i, j, q;
    double norm;

    q = 0;
    do {
        for (i = 0; i < SIZE; i++) {
            v[i] = 0.0;
            for (j = 0; j < SIZE; j++)
                o[i][j] = 0.0;
        }

        make(T, o, u, v, nu, rho, x, y, num, cum, fx, fy, sx, sy);

        bound(o, v, b, N, D, cum, SIZE);

        etalu(o, v, SIZE);

        norm = sqrt(innerproduct(SIZE, v, v) / SIZE);
        printf("||(u,v,p)||%e\n", norm);

        for (i = 0; i < SIZE; i++)
            u[i] -= v[i];

        q++;

    } while ((q < 10) && (norm > 1.0e-8));

    if (q == 10)
        printf(" «ޤǤ \n ");
}
