/*
 * reidai.c --- 򤯤ϥǡ롣
 *               File/file.c
 *
 * ȤСޥ˥奢򤯤 file.data ˤ
 *
 *           ./reidai file.data
 *           ,ѡ 0.04 1
 *           func forc = 0 0
 *
 * Ϥ롣
 */

#include <math.h>
#include <stdio.h>
#include "matutil.h"

#define M  5			/* ưʬ */
#define N  24			/* гʬ */
#define U  432			/* ή®ο  աᣲ(͡ݣ) */
#define P  120			/* Ϥο  С͡ߣ        */
#define T  192			/* ѷο      ԡᣲ(͡ݣ)  */
#define SIZE 984		/* ̤οοӣɣڣš(͡ݣ)  */

#define M1 4			/* ͡ݣ */
#define N2 48			/*    */
#define N4 96			/*    */
#define N9 216			/*    */
#define U2 864			/*    */

#define R1 2.0			/* ¦Ⱦ¤ */
#define R2 5.0			/* ¦Ⱦ¤ */
#define R  5.3			/*   ң    fspase(-R,-R,R,R) */

#define C 3
/*
 *      áᣱʤ¦Ǻ٤ʬ
 *      áᣲʤг¦Ǻ٤ʬ
 *      ʳʤֳ֤ʬ䤹
 */

void number_p(int k, int z[3])
{
    int h;
    h = k / N2;

    if (k % N2 < N) {
	z[0] = k - h * N;
	if (k % N == N - 1)
	    z[2] = k - (h * N + N - 1);
	else
	    z[2] = k - h * N + 1;
	z[1] = k - (h - 1) * N;
    } else {
	if (k % N == N - 1) {
	    z[0] = k - (h + 2) * N + 1;
	    z[2] = k - (h + 1) * N + 1;
	} else {
	    z[0] = k - (h + 1) * N + 1;
	    z[2] = k - h * N + 1;
	}
	z[1] = k - h * N;
    }
}

void number_u(int i, int z[6])
{
    int j, r, s;

    s = i % N2;

    if (s < N) {
	r = i / N2;
	j = N4 * r + 2 * s;

	z[0] = j;
	z[1] = j + N4;
	if (s == N - 1)
	    z[2] = j + 2 - N2;
	else
	    z[2] = j + 2;
	z[3] = j + N2 + 1;
	z[4] = j + 1;
	z[5] = z[3] - 1;
    } else {
	r = i / N2;
	s = s - N;
	j = N4 * r + 2 * s;

	z[1] = j + N4;
	z[3] = z[1] + 1;
	z[5] = j + N2 + 1;

	if (s == N - 1) {
	    z[0] = j + 2 - N2;
	    z[2] = j + N2 + 2;
	    z[4] = j + 2;
	} else {
	    z[0] = j + 2;
	    z[2] = z[1] + 2;
	    z[4] = z[5] + 1;
	}
    }
}

double cal_r(int n, double r)
{
    if (n == 1) {
	return (r - R1) * (r - R1) / (R2 - R1) + R1;
    } else if (n == 2) {
	return sqrt((r - R1) * (R2 - R1)) + R1;
    } else
	return r;
}

double cal_x(int k)
{
    int i, j;
    double Pi, r, theta, dx;

    dx = 1.0;
    Pi = 4.0 * atan(1.0);

    i = k / N;
    j = k % N;

    r = (R2 - R1) * i / M1 + R1;
    theta = 2 * Pi * j / N;

/*  return cal_r(C,r)*cos(theta) + (R2 - r)/(R2 - R1)*dx;*/
    return cal_r(C, r) * cos(theta) + (R2 - cal_r(C, r)) / (R2 - R1) * dx;
}

double cal_y(int k)
{
    int i, j;
    double Pi, r, theta;

    Pi = 4.0 * atan(1.0);

    i = k / N;
    j = k % N;

    r = (R2 - R1) * i / M1 + R1;
    theta = 2 * Pi * j / N;

    return cal_r(C, r) * sin(theta);
}

double b1u(int func, double theta)
{
    double Pi, mu, b1, ur, ut;

    Pi = 4.0 * atan(1.0);
    mu = 0.0;
    b1 = 0.0;

    if (func == 0) {
	ur = mu / R1;
	ut = b1;
    }
    else if (func == 1) {
	if (theta <= Pi / 2.0)
	    ur = 2 * sin(2 * theta) / R1;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else if (func == 2) {
	if (theta <= Pi / 2.0)
	    ur = 4.0 / R1;
	else if (Pi <= theta && theta <= 1.5 * Pi)
	    ur = -2.0 / R1;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else {
      fprintf(stderr, "b1u: func is out of range.\n");
      exit(-1);
    }
    return ur * cos(theta) - ut * sin(theta);
}

double b2u(int func, double theta)
{
    double Pi, mu, b2, ur, ut;

    Pi = 4.0 * atan(1.0);
    mu = 0.0;
    b2 = 1.0;

    if (func == 0) {
	ur = mu / R2;
	ut = b2;
    }
    else if (func == 1) {
	if ((theta >= Pi) && (theta <= 1.5 * Pi))
	    ur = 2 * sin(2 * theta) / R2;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else if (func == 2) {
	if ((theta >= 0.5 * Pi) && (theta <= Pi))
	    ur = 2.0 / R2;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else {
      fprintf(stderr, "b2u: func is out of range.\n");
      exit(-1);
    }
    return ur * cos(theta) - ut * sin(theta);
}

double b1v(int func, double theta)
{
    double Pi, mu, b1, ur, ut;

    Pi = 4.0 * atan(1.0);
    mu = 0.0;
    b1 = 0.0;

    if (func == 0) {
	ur = mu / R1;
	ut = b1;
    }
    else if (func == 1) {
	if (theta <= Pi / 2.0)
	    ur = 2 * sin(2 * theta) / R1;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else if (func == 2) {
	if (theta <= Pi / 2.0)
	    ur = 4.0 / R1;
	else if (Pi <= theta && theta <= 1.5 * Pi)
	    ur = -2.0 / R1;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else {
      fprintf(stderr, "b1v: func is out of range.\n");
      exit(-1);
    }
    return ur * sin(theta) + ut * cos(theta);
}

double b2v(int func, double theta)
{
    double Pi, mu, b2, ur, ut;

    Pi = 4.0 * atan(1.0);
    mu = 0.0;
    b2 = 1.0;

    if (func == 0) {
	ur = mu / R2;
	ut = b2;
    }
    else if (func == 1) {
	if ((theta >= Pi) && (theta <= 1.5 * Pi))
	    ur = 2 * sin(2 * theta) / R2;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else if (func == 2) {
	if ((theta >= 0.5 * Pi) && (theta <= Pi))
	    ur = 2.0 / R2;
	else
	    ur = 0.0;

	ut = 0.0;
    }
    else {
      fprintf(stderr, "b2v: func is out of range.\n");
      exit(-1);
    }
    return ur * sin(theta) + ut * cos(theta);
}

void inver1(double *u, double *b, int j)
{
    int i, p, q;

    for (i = 0; i < N; i++) {
	p = 5 * i + N9 * j;
	q = 2 * i + N4 * j;
	u[q] = b[p];
	u[q + U] = b[p + 1];
	u[i + N * j + U2] = b[p + 2];
	u[q + 1] = b[p + 3];
	u[q + 1 + U] = b[p + 4];
    }
}

void inver2(double *u, double *b, int j)
{
    int i, p, q;

    for (i = 0; i < N2; i++) {
	p = 2 * i + N9 * j + P;
	q = i + N4 * j + N2;
	u[q] = b[p];
	u[q + U] = b[p + 1];
    }
}

int main(int argc, char **argv)
{
    FILE *f;
    int i, j, k, zp[3], zu[6], func, forc;
    double nu, rho, x[U], y[U], Pi, h, theta;

    if (argc != 2) {
	printf("usage: %s <output file>\n", argv[0]);
	exit(1);
    }
    if ((f = fopen(argv[1], "w")) == NULL) {
	fprintf(stderr, "can't open %s \n", argv[1]);
	exit(1);
    }

    printf(",ѡ");
    scanf("%lf %lf", &nu, &rho);
    printf("func forc = ");
    scanf("%d %d", &func, &forc);

    fprintf(f, "%4d   %4d \n", T, U);
    fprintf(f, "\n");

    for (i = 0; i < T; i++) {
	number_p(i, zp);
	number_u(i, zu);
	for (j = 0; j < 3; j++) {
	    x[zu[j]] = cal_x(zp[j]);
	    y[zu[j]] = cal_y(zp[j]);
	}
	x[zu[3]] = 0.5 * (x[zu[1]] + x[zu[2]]);
	y[zu[3]] = 0.5 * (y[zu[1]] + y[zu[2]]);
	x[zu[4]] = 0.5 * (x[zu[0]] + x[zu[2]]);
	y[zu[4]] = 0.5 * (y[zu[0]] + y[zu[2]]);
	x[zu[5]] = 0.5 * (x[zu[0]] + x[zu[1]]);
	y[zu[5]] = 0.5 * (y[zu[0]] + y[zu[1]]);
    }

    for (i = 0; i < U; i++) {
	fprintf(f, "%25.20f  %25.20f \n", x[i], y[i]);
    }
    fprintf(f, "\n");

    for (i = 0; i < T; i++) {
	number_u(i, zu);
	for (j = 0; j < 6; j++) {
	    fprintf(f, " %4d ", zu[j]);
	}
	fprintf(f, "\n");
    }
    fprintf(f, "\n");

    k = 0;
    for (i = 0; i < U; i++) {
	fprintf(f, "%4d \n", k);
	if (i % N4 < N2 && (i % 2) == 0)
	    j = 3;
	else
	    j = 2;
	k += j;
    }
    fprintf(f, "\n");

    fprintf(f, "%4d \n", k);
    fprintf(f, "\n");

    fprintf(f, "%f  %f \n", nu, rho);
    fprintf(f, "\n");

    fprintf(f, " %4d 0 \n", N4);
    fprintf(f, "\n");

    Pi = 4.0 * atan(1.0);
    h = Pi / N;

    for (i = 0; i < N2; i++) {
	theta = i * h;
	j = U - N2 + i;
	fprintf(f, "%4d  %25.20f  %25.20f\n", i, b1u(func, theta),
		b1v(func, theta));
	fprintf(f, "%4d  %25.20f  %25.20f\n", j, b2u(func, theta),
		b2v(func, theta));
    }
    fprintf(f, "\n");

    if (forc == 0) {
	for (i = 0; i < U; i++)
	    fprintf(f, "0.0  0.0\n");
    } else {
	for (i = 0; i < U; i++) {
	    fprintf(f, "%25.20f  %25.20f\n", x[i], y[i]);
	}
    }
    fclose(f);
    return 0;
}
